<script setup>
  import { ref } from 'vue'
  import axios from 'axios'

  const joke = ref('')
  const apiError = ref('')

  async function loadChuckNorrisJoke() {
    joke.value = ''
    apiError.value = ''

    try {
      // Uncomment to provoke response error
      // const jokeResponse = await axios.get('https://api.chucknorris.io/jokes/random/error')
      const jokeResponse = await axios.get('https://api.chucknorris.io/jokes/random')
      joke.value = jokeResponse.data.value
    } catch (err) {
      console.error(err);
      if (err.isAxiosError && err.status === 401) {
        apiError.value = 'You must be logged in'
      } else {
        apiError.value = 'Unknown error occurred'
      }
    }
  }
</script>

<template>
  <main class="container py-5">
    <p>{{joke}}</p>
    <button type="button" class="btn btn-primary" @click="loadChuckNorrisJoke">
      Load Joke
    </button>
  </main>
</template>
